package com.ybxiang.nms.server.ejb.session;

import javax.annotation.Resource;
import javax.annotation.security.DeclareRoles;
import javax.annotation.security.RolesAllowed;
import javax.ejb.EJBContext;
import javax.ejb.Remote;
import javax.ejb.Stateless;


@Stateless
@Remote(ISecuredRemoteSession.class)
@DeclareRoles("bean")
public class SecuredRemoteSession implements ISecuredRemoteSession{
   
    @Override
    public int add(int a, int b) { 	
        return a + b;
    }

    @Override
    public int subtract(int a, int b) {
        return a - b;
    }
    
    @Resource
    private EJBContext context;

    @Override
    @RolesAllowed("bean")
    public String getName()
    {
         return   getNameFree();
    }

    @Override
    public String getNameFree ()
    {
            String aName = "";
            if (context.getCallerPrincipal() != null) {
                    aName = context.getCallerPrincipal().getName();
            }
            String log = "name " + aName + " " + context.isCallerInRole("bean");
            System.out.println("getNameFree************************************************");
            System.out.println(log);
            System.out.println("getNameFree************************************************");
            
            return "name " + aName + " " + context.isCallerInRole("bean");
    }    
    
}
